# coding=utf-8
r"""
This code was generated by
\ / _    _  _|   _  _
 | (_)\/(_)(_|\/| |(/_  v1.0.0
      /       /
"""

from tests import IntegrationTestCase
from tests.holodeck import Request
from twilio.base import serialize
from twilio.base.exceptions import TwilioException
from twilio.http.response import Response


class DeviceCodeTestCase(IntegrationTestCase):

    def test_create_request(self):
        self.holodeck.mock(Response(500, ''))

        with self.assertRaises(TwilioException):
            self.client.oauth.v1.device_code.create(client_sid="client_sid", scopes=['scopes'])

        values = {'ClientSid': "client_sid", 'Scopes': serialize.map(['scopes'], lambda e: e), }

        self.holodeck.assert_has_request(Request(
            'post',
            'https://oauth.twilio.com/v1/device/code',
            data=values,
        ))

    def test_create_response(self):
        self.holodeck.mock(Response(
            201,
            '''
            {
                "device_code": "LiwuhE0bIhqemK6sd34tXfobVCR9yrk0",
                "user_code": "Hkf1WaID3",
                "verification_uri": "v1/oauth2/device/activate",
                "verification_uri_complete": "v1/oauth2/device/activate?user_code=Hkf1WaID3",
                "expires_in": 299,
                "interval": 5
            }
            '''
        ))

        actual = self.client.oauth.v1.device_code.create(client_sid="client_sid", scopes=['scopes'])

        self.assertIsNotNone(actual)
